<template lang="pug">
    div
        link(rel="stylesheet" href="https://unpkg.com/leaflet@1.6.0/dist/leaflet.css"
            integrity="sha512-xwE/Az9zrjBIphAcBb3F6JVqxf46+CDLwfLMHloNu6KEQCAWi6HcDUbeOfBIptF7tcCzusKFjFw2yuvEpDL9wQ=="
            crossorigin=""
        )
        div(style="height:250px")
            l-map(
                :zoom="13"
                :center="center"
            )
                l-tile-layer(
                    url="https://{s}.tile.osm.org/{z}/{x}/{y}.png"
                )
                l-polygon(
                    v-for="polygon in polygons"
                    :lat-lngs="polygon"
                )
                l-marker(
                    v-for="point in points"
                    :lat-lng="point"
                )
                l-polyline(
                    v-for="polyline in polylines"
                    :lat-lngs="polyline"
                )
        v-card.my-8
            v-card-title Upload GIS data
            v-card-text
                v-select(
                    v-model="uploadType"
                    label="Please select geometry type"
                    :items="geometryTypes"
                )
                v-file-input(
                    v-model="file"
                    label="Please upload a ziped shapefile"
                )
                v-btn(
                    color="primary"
                    @click="upload"
                ) Upload Data

</template>

<script>
import { mapGetters, mapActions } from "vuex";
import { LMap, LTileLayer, LPolygon, LMarker, LPolyline } from "vue2-leaflet";
export default {
    name: "gis",
    components: {
        LMap,
        LTileLayer,
        LPolygon,
        LMarker,
        LPolyline,
        GisMap: () => import("../components/map")
    },
    data() {
        return {
            center: [-1.99870001632014, 53.5058606499777],
            uploadType: null,
            geometryTypes: [
                {
                    text: "Point",
                    value: "point"
                },
                {
                    text: "Polygon",
                    value: "polygon"
                },
                {
                    text: "Polyline",
                    value: "polyline"
                }
            ],
            file: null
        };
    },
    mounted() {
        this.fetchData();
    },
    computed: {
        ...mapGetters({
            getATrench: "trench/getATrench",
            getAllPoint: "point/getAllPoint",
            getAllPolyline: "polyline/getAllPolyline",
            getAllPolygon: "polygon/getAllPolygon"
        }),
        polygons() {
            if (!this.getAllPolygon.data) {
                return [];
            }
            return this.getAllPolygon.data.map(el => {
                return el.attributes.geometry.coordinates.map(point => {
                    return point.map(latLong => {
                        return [latLong[1], latLong[0]];
                    });
                });
            });
        },
        points() {
            if (!this.getAllPoint.data) {
                return [];
            }
            return this.getAllPoint.data.map(el => {
                return [
                    el.attributes.geometry.coordinates[1],
                    el.attributes.geometry.coordinates[0]
                ];
            });
        },
        polylines() {
            if (!this.getAllPolyline.data) {
                return [];
            }
            return this.getAllPolyline.data.map(el => {
                return el.attributes.geometry.coordinates.map(point => {
                    return [point[1], point[0]];
                });
            });
        },
        gis() {
            let data = [];
            if (this.getAllPoint !== null) {
                data = data.concat(this.getAllPoint.data);
            }
            if (this.getAllPolyline !== null) {
                data = data.concat(this.getAllPolyline.data);
            }
            if (this.getAllPolygon !== null) {
                data = data.concat(this.getAllPolygon.data);
            }
            return data;
        }
    },
    methods: {
        ...mapActions({
            getCurrentURL: "getCurrentURL",
            fetchAllPoint: "point/fetchAllPoint",
            fetchAllPolygon: "polygon/fetchAllPolygon",
            fetchAllPolyline: "polyline/fetchAllPolyline",
            createAPoint: "point/createAPoint",
            createAPolygon: "polygon/createAPolygon",
            createAPolyline: "polyline/createAPolyline"
        }),
        fetchData() {
            this.getCurrentURL({
                projectID: this.projectid,
                siteID: this.siteid,
                trenchID: this.trenchid
            });
            this.fetchAllPoint({
                url: this.getATrench.data.relationships.gis.links.points
            });
            this.fetchAllPolyline({
                url: this.getATrench.data.relationships.gis.links.polylines
            });
            this.fetchAllPolygon({
                url: this.getATrench.data.relationships.gis.links.polygons
            });
        },
        upload() {
            let data = new FormData();
            data.append("geometry", this.file);
            if (this.uploadType === "point") {
                this.createAPoint({
                    url: this.getATrench.data.relationships.gis.links.points,
                    payload: data
                });
            } else if (this.uploadType === "polygon") {
                this.createAPoint({
                    url: this.getATrench.data.relationships.gis.links.polygons,
                    payload: data
                });
            } else if (this.uploadType === "polyline") {
                this.createAPoint({
                    url: this.getATrench.data.relationships.gis.links.polylines,
                    payload: data
                });
            }
        }
    }
};
</script>

<style scoped>
.h-100 {
    height: 100%;
}
.w-100 {
    width: 100%;
}
</style>
